---
title: 21.09.26 医学英语Pre
tags: []
id: '786'
categories:
  - - 医学与通识
date: 2021-09-25 21:51:46
---

## [Slides File](https://limour.top/nextcloud/index.php/s/kLKmEmr2mDq3Gni)

Good morning, everyone. I appreciate the opportunity to be with you today. I am here to briefly introduce to you spatial transcriptomics, a bioinformatics technology, and its significance for the overall development of medical science.

During the next five minutes, I shall talk about what spatial transcriptomics is, why we need it, how to use it, and its four points of meaning.

When we discuss gene expression patterns, we tend to focus on two dimensions: Spatial and temporal dimensions. By selecting samples at different time points and then performing single-cell RNA sequencing, we have been able to obtain information on the “temporal dynamic expression” of genes at the single-cell level. But using this seq process will make us inevitably lose the spatial information of tissue samples. It is to solve this problem that researchers set out to develop: spatial analysis of the transcriptome.

**Spatial Transcriptomics (ST)** is a technology used to characterize gene expression profiles while retaining information of the spatial tissue context. 

The term spatial transcriptomics was first introduced by an article published in Science in 2016 and this technology was titled by Nature as [“Method of the Year 2020”](https://www.nature.com/articles/s41592-020-01042-x).  

We can briefly understand the main results of the "spatial transcriptome" technology introduced in this article through the picture on the upper right of the above picture. The picture is divided into two parts, the upper part is a tissue section, and every spot we see is a detection area. After finishing the spatial transcriptome, we can get some regional marker genes (regional markers) through a special toolkit for data analysis. For example, the gene "Penk" in the figure above is the "marker gene of the green region". The following is the result of in situ sequence experiment (in situ sequence). As you can see, the results of in situ sequencing below verify the results of the spatial transcriptome.

There are roughly four groups of methodologies to conduct spatial transcriptomics. These groups all have a large variety of techniques. It is good to keep in mind that not all spatial techniques have a single-cell resolution, or provide information on the whole transcriptome.

### The first method is called in silico construction.

These methods computationally map single cells back into space, with little or no prior knowledge about the position of the sequenced cells. These methods are therefore compatible with single-cell RNA sequencing.

### The second method is called Microdissection.

Microdissection is a technique where you isolate regions of interest from within a sample. Isolation is done by lasering or cutting. From these tissue pieces, RNA is isolated, processed, and sequenced.

### The third method is called in situ sequencing.

In situ sequencing is the sequencing of RNA while the cell stays within the tissue context. The sequenced RNAs are visualized using fluorescent probes. This method also does not allow for full transcriptome analysis.

### The last method is in situ capturing based on spatial barcodes.

In situ capturing is a spatial transcriptomics method in which transcripts are first captured and barcoded _within_ the tissue. Then, sequencing is performed _outside_ the tissue. The tissue is imaged, which allows the transcriptomics data to be overlayed with the tissue images.

Okay, everyone may ask a question. Now that we have single-cell RNA sequencing technology, why should we develop **Spatial Transcriptomics**?

Firstly, ST provides spatial information, overcoming the weakness of single-cell RNA sequencing.

Secondly, ST only requires tissue sections. single-cell RNA sequencing requires the formation of protoplasts, which is difficult to produce in certain species.

Thirdly, Spatial information can be used to annotate cell types with histological knowledge, which satisfy the demand of conducting research on non-model

In this part, I will take the workflow of the last method as an example to introduce how to use **Spatial Transcriptomics.**

#### The first step is to prepare your sample

Embed, section, and place fresh frozen or FFPE tissue onto a Capture Area of the gene expression slide. Each Capture Area has thousands of barcoded spots containing millions of capture oligonucleotides with spatial barcodes unique to that spot.

#### The second step is to Stain and image the tissue

Utilize standard fixation and staining techniques, including hematoxylin and eosin (H&E) staining, to visualize tissue sections on slides using a brightfield microscope and immunofluorescence staining to visualize protein detection in tissue sections on slides using a fluorescent microscope.

#### The third step is to permeabilize tissue and construct library.

For fresh frozen tissue, the tissue is permeabilized to release mRNA from the cells, which binds to the spatially barcoded oligonucleotides present on the spots. A reverse transcription reaction produces cDNA from the captured mRNA. The barcoded cDNA is then pooled for downstream processing to generate a sequencing-ready library. For FFPE tissues, tissue is permeabilized to release ligated probe pairs from the cells, which bind to the spatially barcoded oligonucleotides present on the spots. Spatial barcodes are added via an extension reaction. The barcoded molecules are then pooled for downstream processing to generate a sequencing-ready library.

#### The fourth step is to sequence.

The resulting 10x barcoded library is compatible with standard NGS short-read sequencing on Illumina sequencers for massive transcriptional profiling of entire tissue sections.

#### The fifth step is to analyze and visualize your data.

You can use Seurat for analysis and visualization. These are my example R codes and results.

I'd now like to move on to the significance.

ST can map and measure where all gene activity is occurring in normal and diseased tissue. So we can gain a complete view of disease complexity.

ST can visualize the whole transcriptome to identify novel targets and their locations in the tissue microenvironment. So we can discover new biomarkers.

ST can characterize cell populations and their locations within a tissue. So we can map the spatial organization of cell atlases.

ST can combine spatial gene expression patterns with developmental time points. So we can identify spatiotemporal gene expression patterns.

That's all I have to say about **Spatial Transcriptomics.**

These are the REFERENCES I used.

If you want to know more, you can visit my blog. And you can also get this slides file and my oral draft on it. The access password is my student ID.

Thank you for listening. I'd be grateful if you could ask your questions.