---
title: 实用免疫学（七）适应性免疫：体液免疫
tags: []
id: '1747'
categories:
  - - 巨塔砖石
date: 2022-03-07 10:49:06
---

环境中的病原体侵入生物机体后，胞外菌寄居在宿主的细胞外组织液、淋巴液和血液等体液中。侵入的病原体会刺激特异性B细胞活化并分化为浆细胞。根据B细胞对Ag的反应，将Ag分为TI－Ag（胸腺非依赖性抗原）和TD－Ag（胸腺依赖性抗原）。活化的B细胞通过产生抗体来发挥效应。

## TI－Ag

该类抗原刺激机体产生抗体无需T细胞的辅助，可以分为TI－1Ag和TI－2Ag。

*   TI－1Ag
*   既有抗原表位又有丝裂原性质
*   丝裂原性质：无需APC提呈即可非特异性刺激多克隆T、B细胞发生有丝分裂,属于非特异的淋巴细胞多克隆激活剂
*   具有B细胞多克隆激活作用，如细菌LPS等，成熟或未成熟B细胞均可对其产生应答
*   婴儿和新生动物B细胞发育不成熟，不能对TI－2Ag产生应答，但仍能对TI－1AG产生应答
*   高浓度经B细胞膜上的丝裂原受体（如TLR4）识别，非特异性地诱导多克隆B细胞增殖和分化
*   低浓度需经BCR识别而特异性地诱导B细胞增殖和分化
*   多克隆增殖：刺激机体多个B细胞克隆

*   TI－2Ag
*   其表面含多个重复B细胞表位，如肺炎链球菌荚膜多糖、聚合鞭毛素等
*   仅能刺激成熟的B细胞，且不能引起B细胞的多克隆增殖
*   诱导抗原特异性的成熟B细胞BCR交联反应而产生B细胞的活化
*   也可通过结合补体分子C3d、C3dg等激活补体旁路MBL途径

TI抗原一般激活的主要是CD5+B1细胞，所产生的主要为低亲和力的IgM抗体。由于无特异性T细胞辅助，TI抗原一般不能诱导Ig类别转换、抗体亲和力成熟和记忆B细胞产生

![](https://img-cdn.limour.top/blog/20220309230740.png)

BCR复合体图示

*   BCR复合物：由mIg（膜表面免疫球蛋白）和Igα/β（CD79a/b）异二聚体两部分组成
*   不同发育阶段的mIg不同：成熟的B细胞为IgM和IgD；浆细胞不再表达
*   mIg胞质区只有3AA，不能高效传递抗原刺激信号，因此需要靠胞质区长且有ITAM的Igα/β异二聚体来传递抗原激活信号，同时后者的跨膜区极性AA能与BCR的跨膜区的TAST和YSTTVT中的极性AA（T、S）形成盐键来稳定BCR结构
*   Igα/β异二聚体胞外区借二硫键连接。ITAM主要通过酪氨酸磷酸化募集下游信号分子。

![](https://img-cdn.limour.top/blog/20220310001818.png)

*   BCR交联激活流程
*   多个重复B细胞表位的TI-2Ag聚集多个BCR复合体，同时TI-2Ag结合C3d聚集CD21-CD19，形成BCR-Ag-Cd3dg-CD21-CD19。CD19募集Fyn/Lyn，聚集的Src家族（受体相关性蛋白酪氨酸激酶）彼此成簇而发生相互磷酸化，同时使CD79CD19的ITAM磷酸化，进一步导致SyK酪氨酸激酶活化（[与TCR下游](https://limour.top/1722.html)ZAP-70类似），接着通过活化PLC-γ和EGF，使B细胞增殖分化

*   B细胞活化共受体复合物：能促进BCR对抗原的识别和B细胞活化的受体
*   CD19：除将细胞外各B细胞谱系均有，受体酪氨酸激酶，通过pY（酪氨酸磷酸化）募集Src PTK家族成员的LYN等信号分子。
*   CD21：主要表达于成熟B细胞，II型补体受体（CR2，C3d受体）和EB病毒受体（感染后持续增殖转化）；能特异性结合C3d，自身发生pY，进一步活化CD79上的ITAM，为招募PI3K提供结合位点，同时定位PI3K到共辅助受体分子上；能结合CD23，促进B细胞分裂增殖
*   CD81：促进B细胞增殖

## TD-Ag

TD抗原主要为蛋白质抗原，如病原微生物、血细胞、血清蛋白。BCR首先特异性结合抗原，产生B细胞活化的第一信号，B细胞内化BCR所结合的抗原，并对抗原进行加工，形成抗原肽－MHCII类分子复合物（pMHC）呈递给抗原特异性Th识别，Th活化后通过表达的CD40L与B细胞表面的CD40结合，又提供B细胞活化的第二信号。同时活化的T细胞分泌的细胞因子诱导B细胞进一步活化，分化为浆细胞。

![](https://img-cdn.limour.top/blog/20220309232044.png)

B细胞对TD抗原的识别

*   成熟的初始B细胞定居淋巴滤泡：成熟的初始B细胞高表达趋化因子受体CXCR5，其配体CXCL13由分布在淋巴滤泡的基质细胞和滤泡树突细胞分泌。定居滤泡的初始B细胞大部分会在淋巴细胞再循环中遭遇抗原，如果几个月没有接触抗原则会发生凋亡
*   TD－Ag的获取与识别：血源性抗原进入脾脏，组织中的抗原进入淋巴结，被补体共价修饰后，能同时结合BCR和共受体复合物。小的可溶性抗原能够在淋巴液中循环，经管道进入淋巴滤泡，被滤泡中的B细胞识别。较大的复杂抗原，可以形成免疫复合物或与补体片段共价结合，被巨噬细胞和树突细胞表面的补体受体和FcγR捕获，持续表达在表面，供B细胞识别  
    与抗原接触2～4分钟后，B细胞的细胞膜会发生扩张，存在于细胞膜上的BCR会进行重新排列与聚集，更好地与抗原结合，为信号传递及B细胞的再次活化做准备；识别BCR后，B细胞在保持CXCR5表达的同时上调CCR7受体  
    同时在T细胞区，初始T细胞通过识别DC表面的MHC分子呈递的抗原肽而被活化，上调表达CD40L；下调CCR7并上调CXCR5
*   Th细胞与第一次活化的B细胞双向奔赴：CCR7的配体趋化因子是在T细胞区的CCL19和CCL21，CXCR5的配体趋化因子是在滤泡的CXCL13。因此活化的B细胞向T细胞区与滤泡区的交界处迁移，活化的T细胞向滤泡区移动
*   接触抗原的B细胞2小时后会内吞抗原，处理加工产生的抗原肽段经MHCII类分子呈递，表达在B细胞的表面。在交界区与活化的Th细胞相遇将抗原呈递给Th细胞，同时表达B7与T细胞表面的CD28结合而提供Th活化的第二信号，同时接受活化Th细胞表面的CD40L和分泌的细胞因子（IL2、IL4、IL21、IL6、IFNγ；活化的巨噬细胞也会分泌IL1、IL7共同作用），被充分活化。
*   同时部分激活的Th细胞开始表达CXCR5，进入淋巴滤泡，分化为Tfh。
*   充分活化的B细胞分两部分，一部分不再表达CXCR5，转为表达EB12和CXCR4，迁移到滤泡外区域，如淋巴结髓索，在4天内增殖分裂并分化为早期浆细胞，形成原发灶，产生少量以IgM为主的抗体，参与早期防御，可出现抗体类别转换。另一部分下调CCR7，表达CXCR5和CXCR4，进入淋巴滤泡，继续增殖分裂，形成生发中心，在Tfh细胞的帮助下，经历B细胞的抗体基因可变区高频率点突变和抗原选择的抗体亲和力成熟，以及抗体类别转化，在6~10天内，最终产生高亲和力抗体的浆细胞和记忆B细胞。高亲和力抗体的浆细胞迁移至骨髓。
*   浆细胞：除少量线粒体外，多粗糙型内质网，表面Ig表达水平接近0，多迁往骨髓、不分泌细胞因子
*   记忆B细胞：来源于生发中心，部分留在淋巴滤泡、大部分进入血液循环，再次遇到同一抗原刺激时，能在记忆性Th细胞协助下活化，表面标记分子CD19、CD27，表达特异性BCR

*   生发中心  
    内层暗区的生发中心母细胞产生生发中心细胞，向外移动形成明区。明区中含有较多的FDC和Tfh细胞、巨噬细胞，大量竞争不到抗原刺激信号和T细胞辅助的B细胞会发生凋亡然后被巨噬细胞吞噬清除
*   生发中心母细胞：每6~8小时分裂一次的B细胞，低表达mIg
*   生发中心细胞：体积较小，重新高表达mIg的B细胞

*   AID介导B细胞的抗体基因突变
*   抗原和CD40L刺激信号激活诱导B细胞的AID，介导B细胞在暗区发生SHM，后B细胞在明区接受阳性选择，由于SHM的随机性，拥有高亲和力的BCR的B更能从FDC竞争获得抗原，得以优势扩增。同时BCR激活也能通过Akt通路和PI3K一直凋亡蛋白产生，促进P53降解，进一步保证高亲和力BCRB细胞的增殖
*   体细胞高频突变SHM：在基因重排的基础上，成熟B细胞在外周淋巴器官生发中心接受抗原刺激后在编码CDR部位的基因序列发生点突变，以增加抗体多样性

*   抗体类别转换
*   Ig重链基因大约200kb，μ、δ、γ、ε和α重链C基因位于重排后的VDJ基因的下游。mIgM、mIgD来源于同一mRNA的可变剪切，而其他三类Ig的表达需要Ig重链恒定区基因发生断裂后重排，从连接Cμ转换为连接Cγ、Cα、Cε基因，进而产生抗体的类别转换为IgG、IgA、IgE。因为Ig重链的V区保持不变，因此类别转换不涉及抗体抗原结合特异性。
*   AID首先攻击抗体重链S区WGCW/WCGW碱基对中的C，使其脱氨形成U，然后机体通过BER和MMR等修复机制形成DSB（DNA双链断裂），然后通过非同源重组的方式连接，从而形成抗体基因的类别转换。
*   当没有成功进行非同源末端连接时，DNA重新结合可能使用微同源末端结合。除μ和δ能同时表达外，B细胞只会表达其中一种抗体类别

![](https://img-cdn.limour.top/blog/20220313195029.png)

## 抗体的结构和功能

![](https://img-cdn.limour.top/blog/20220313203119.png)

Ig基因的类别转换受到抗原以及Th细胞等分泌的细胞因子调节

*   IgM
*   在胚胎后期开始合成
*   可分为单体型mIgM（未成熟B细胞标志）和分泌型五聚体，C区4个结构域，需要J链辅助
*   IgM与抗原形成复合物，激活补体经典途径和旁路途径
*   IgM在初次免疫应答最早出现，具有早期诊断价值，若脐带血中IgM含量升高，则提示宫内感染，也是天然血型抗体
*   C区：H/L链靠近C端的氨基酸组成和排列相对恒定的区域，占H的3/4、L的1/2  
    依据CH的差异分五类，IgM是其中无亚型的一类，长度与结构域数量有关  
    依据CL的差异可以分κ型和λ型，其中λ链C区个别氨基酸差异可以分λ1~4，长度基本一致，人κ:λ=2:1
*   J链：将其连接为聚体

*   IgD
*   随时能够合成，半衰期相当短
*   可分为血清型和膜结合型mIgD（成熟B细胞标志），C区3个结构域
*   只有重复多价的抗原才能触发IgD的信号，IgD可结合并激活嗜碱性粒细胞和肥大细胞，继而使其产生抗微生物的因子以参与气道的免疫防御，结合IgD的嗜碱性粒细胞还可以释放B细胞稳态因子，维持B细胞的数量。
*   IgD的结构灵活多变，在IgM缺陷时可以替代IgM的功能。

*   IgG
*   出生后三个月开始合成，3-5岁接近成年人水平，半衰期最长
*   其在血清中含量最高，可以分1234中亚类，C区3个结构域
*   IL-4刺激IgG1、IFNγ刺激IgG2a、TGFβ刺激IgG2b、IFNγ刺激IgG3、IL10刺激IgG4
*   除IgG2外，唯IgG可通过胎盘屏障（胎盘母体一侧的滋养层细胞表达一种IgG输送蛋白FcRn，IgG可以选择性地与FcRn结合，从而转移到滋养层细胞内，并主动进入胎儿血液循环中），同时也存在母乳中起自然被动免疫作用
*   是再次免疫的主要抗体，IgG312激活补体的经典途径、参与调理作用和ADCC；IgG4激活补体旁路途径
*   介导II、III型超敏反应
*   IgG能够在特定抗原与亲细胞的IgE结合介导过敏反应之前将抗原拦截。因此，IgG能够阻止少量抗原诱发全身性的过敏反应

*   IgA
*   出生后4~6个月开始合成
*   分血清型和分泌型（二聚体），有1、2亚类，C区3个结构域，需要J链和SP辅助
*   TGFβ和IL5刺激抗体类别转换成IgA
*   SP：分泌片/分泌成分，由黏膜上皮细胞合成  
    结合于IgA二聚体上，形成分泌性sIgA，保护铰链区免受蛋白酶降解，同时介导IgA转运至黏膜表面（和pIgR相关）
*   参与黏膜免疫，和边缘区的抗感染，存在于母乳中，IgA1激活补体旁路途径，参与调理作用和ADCC

*   IgE
*   出现较晚，在血清中含量最低，对热不稳定
*   C区有4个结构域，具有亲细胞性
*   能激活补体旁路途径，与肥大细胞和嗜酸性细胞表面FcεRI结合介导I型超敏反应
*   主要参与抗寄生虫感染