---
title: 实用免疫学（二）固有免疫应答
tags: []
id: '1699'
categories:
  - - 巨塔砖石
date: 2022-02-19 16:15:11
---

固有免疫应答分三个阶段：前四小时的瞬时阶段，前四天的早期阶段和之后的适应性免疫应答诱导阶段。瞬时阶段可终止绝大多数的病原体感染。

## 瞬时阶段

病原体接触机体，首先遭到屏障结构的阻挡。

![](https://img-cdn.limour.top/blog/20220219131730.png)

物理屏障：上皮细胞紧密连接、黏膜分泌黏液（被黏液包裹的微生物难以黏附表皮细胞）、纤毛摆动、尿液冲洗。

某些病原体会激活补体除经典途径外的途径，被裂解杀伤。产生的C5a/C3a可直接作用于肥大细胞，释放炎性介质和促炎因子，使局部血管扩张、通透性增强，帮助中性粒细胞（小吞噬细胞）活化和聚集。

活化和聚集的中性粒细胞是最早也是主要的抗细菌和真菌的效应细胞，含有巨噬细胞不具有的MPO（颗粒的部分）杀菌系统，完成一轮吞噬后死亡，构成脓汁的主要成分。绝大部分感染终止于此。

少量突破屏障的，遭局部巨噬细胞（大吞噬细胞）的吞噬。巨噬细胞来源于离开血液循环、进入各组织的单核细胞。在神经组织称为小胶质细胞、在肝脏称为库普弗细胞、在骨组织称为破骨细胞（当初的发现者不知道它们都是一类细胞，不同的发现者在不同的组织中分别发现了它们，因此给了它们不同的名字，但其实都是一类细胞）。巨噬细胞表面有多种受体。

![](https://img-cdn.limour.top/blog/20220219135311.png)

被巨噬细胞吞噬的病原体会遭到氧依赖的ROI、RNI和氧非依赖酸性环境、溶酶体（巨噬细胞长寿命，可不断产生溶酶体）、抗菌肽等的杀伤。

## 早期阶段

进入细胞内的病毒和细菌将由活化的NK细胞、γδT细胞和NKT细胞处理，都通过穿孔素/颗粒酶来杀伤。

*   NK细胞：来源于骨髓的淋巴样干细胞，TCR-mIg-CD56+CD16+。  
    比T细胞和B细胞大，含有细胞毒作用的胞质颗粒  
    无特异性抗原识别受体，有KIR（免疫球蛋白样）、KLR（凝集素样）、NCR（细胞毒，识别非MHCI类分子的活化性受体）  
    ADCC：细胞因子受体、FcγR  
    NK细胞只表达一部分受体，并不表达全部的受体。  
    MHCI类分子与抑制性KIR、KLR结合防止杀伤正常细胞  
    非MHCI类分子与NCR、激活性KIR、KLR结合激活NK细胞，释放细胞因子IFN-γ。
*   ILL：固有淋巴样细胞，介于适应性与固有之间，通过为数不多的基因重排，产生有限多样性的BCR/TCR，不克隆也可发生应答，只出现在特定部位。  
    γδT细胞，无MHC限制性、多双阴性，直接识别靶抗原，分布于黏膜和皮下  
    NKT细胞，无MHC限制性、CD56+TCR+，识别CD1提呈脂类抗原，分布胸腺和外周淋巴器官  
    B1细胞，发育中出现较早的CD5+mIgM+B细胞；主要分布于胸腹腔、肠壁固有层。其BCR不具有多样性，但可以直接识别多糖，无记忆性，产生的抗体以IgM为主。

同时，受抗原刺激的B1细胞在2天内产生IgM，在补体的协同作用下，对少数进入血液的病原体进行杀伤。

感染继续，巨噬细胞被募集、活化；并产生大量促炎细胞因子，扩大固有免疫应答和炎症反应。

*   IFN：干扰素  
    IFN-γ，**来自NK细胞**、活化T细胞；激活巨细胞、促进Th1、抑制Th2
*   趋化因子：  
    CC：[CCL3](https://en.wikipedia.org/wiki/CCL3)（MIP-1α），趋化、促炎、平衡
*   CSF：集落刺激因子，刺激造血细胞分化、增殖  
    GM-CSF，粒细胞-巨噬细胞集落刺激因子
*   IL：白介素，在白细胞间起相互作用。  
    IL-6，来自巨噬细胞，诱导CRP（肝合成的应对炎症的血浆蛋白）合成、内生致热源  
    IL-1，来自巨噬细胞，诱导IL-6、CRP合成、内生致热原、**激活NK细胞**
*   TNF：肿瘤坏死因子，使肿瘤出血坏死。  
    TNF-α：活化的单核-巨噬细胞产生

小肠和呼吸道上皮组织中的DC能把树突经上皮间隙伸到腔道内，捕获被脓液中的抗原。

*   未成熟的cDC表达CLR、MR、FcR，捕获Ag，并通过胞饮作用摄取细胞环境中的可溶性蛋白
*   pDC表达TLR-7、9，识别病毒（ssRNA）后大量产生I 型干扰素（IFN-α、β），IL-12、6，TNF-α