---
title: 树莓派建立网络收音机
tags: []
id: '1465'
categories:
  - - Raspberry Pi
date: 2022-01-22 23:02:31
---

## 第一步 安装必要程序（可选）

*   驱动程序：sudo apt-get install rtl-sdr
*   依赖：sudo apt-get install librtlsdr-dev
*   （PC）Software Defined Radio Package：[https://airspy.com/download/](https://airspy.com/download/)

## 第二步 禁用冲突的内核模块

*   sudo nano /etc/modprobe.d/blacklist-rtl28.conf

```conf
blacklist rtl8xxxu
blacklist dvb_usb_rtl28xxu
```

## 第三步 通过docker使用openwebrx

项目地址：[https://github.com/jketterl/openwebrx/wiki/Getting-Started-using-Docker](https://github.com/jketterl/openwebrx/wiki/Getting-Started-using-Docker)

```shell
 proxychains4 docker pull jketterl/openwebrx:stable
 docker volume create openwebrx-settings
 docker run --device /dev/bus/usb -p 8073:8073 \
 --tmpfs=/tmp/openwebrx \
 -v openwebrx-settings:/var/lib/openwebrx \
 jketterl/openwebrx:stable
 docker exec -it [container] /bin/bash
 python3 /opt/openwebrx/openwebrx.py admin adduser limour
```

[![](https://img-cdn.limour.top/blog_wp/2022/01/image-12.png)](https://img-cdn.limour.top/blog_wp/2022/01/image-12.png)

效果如图：[https://webrx.frp.limour.top/](https://webrx.frp.limour.top/)

## 第四步 SPYSERVER

说明：https://www.rtl-sdr.com/rtl-sdr-tutorial-setting-up-and-using-the-spyserver-remote-streaming-server-with-an-rtl-sdr/

```shell
wget -O spyserver.tgz https://airspy.com/?ddownload=5795
tar xvzf spyserver.tgz
./spyserver
```

[![](https://img-cdn.limour.top/blog_wp/2022/01/image-13.png)](https://img-cdn.limour.top/blog_wp/2022/01/image-13.png)

效果